package app

import (
	"errors"
	"fmt"
	"io/ioutil"
	"strings"

	"gitlab.com/revalus/grm/config"
)

func getFileContent(pathToFile string) ([]byte, error) {
	return ioutil.ReadFile(pathToFile)
}

func getFileExcension(pathToFile string) (string, error) {
	splittedFileName := strings.Split(pathToFile, ".")

	if len(splittedFileName) == 1 {
		msg := fmt.Sprintf("excension for file \"%v\", not found", splittedFileName)
		return "", errors.New(msg)
	}

	fileExcension := splittedFileName[len(splittedFileName)-1]

	return fileExcension, nil
}

func checkIsItemInSlice(check string, sliceToCheck []string) bool {
	for _, item := range sliceToCheck {
		if item == check {
			return true
		}
	}

	return false
}

func checkAnyOfItemInSlice(check []string, sliceToCheck []string) bool {

	for _, item := range check {
		if checkIsItemInSlice(item, sliceToCheck) {
			return true
		}
	}

	return false
}

func reverseRepositoryConfigs(repositories []config.RepositoryConfig) []config.RepositoryConfig {
	for i, j := 0, len(repositories)-1; i < j; i, j = i+1, j-1 {
		repositories[i], repositories[j] = repositories[j], repositories[i]
	}
	return repositories
}
